/**
 * Created by tingkl on 16/8/12.
 */
/**
 * Created by tingkl on 16/8/1.
 */
var $ = require('jquery');
var jss = require('jss');
function LineMove(selector, pointChain, pointMap, pointName, ratio) {
	this.$dom = $(selector);
	this.pointChain = pointChain.split(' ');
	this.pointMap = this.reform(pointMap);
	this.pointName = pointName;
	this.ratio = ratio || 3;
	this.moving = false;
}
LineMove.prototype.isMoving = function () {
	return this.moving;
};
LineMove.prototype.reform = function (pointMap) {
	var fromCss = pointMap.fromCss;
	if (fromCss) {
		delete pointMap.fromCss;
		var pointName;
		var css;
		for (var i = 0; i< this.pointChain.length; i++) {
			pointName = this.pointChain[i];
			if (!pointMap[pointName]) {
				css = jss.getAll('.' + pointName);
				pointMap[pointName] = {left: Number(css.left.replace('px', '')), top: Number(css.top.replace('px', ''))};
			}
		}
		//console.log(JSON.stringify(pointMap));
	}
	return pointMap;
};
LineMove.prototype.moveTo = function(toPoint) {
	var $dom = this.$dom;
	$dom.stop();
	this.moving = true;
	var index = 0;
	var point;
	var toIndex = -1;
	var fromIndex = -1;
	var me = this;
	var pointMap = me.pointMap;
	while(toIndex < 0 || fromIndex < 0) {
		point = this.pointChain[index];
		if (!point) {
			break;
		}
		if (point === toPoint) {
			toIndex = index;
		}
		if (point === me.pointName) {
			fromIndex = index;
		}
		index++;
	}
	var from = Math.min(fromIndex, toIndex);
	var to = fromIndex + toIndex - from + 1;
	var points = this.pointChain.slice(from, to);
	if (fromIndex > toIndex) {
		points = points.reverse();
	}
	function run(start, end) {
		var pointStartName = points[start];
		var pointEndName = points[end];
		if (pointEndName) {
			var pointStart = pointMap[pointStartName];
			var pointEnd = pointMap[pointEndName];
			var speed = Math.abs(pointEnd.left + pointEnd.top - pointStart.left - pointStart.top) * me.ratio;
			$dom.animate({
				left: pointEnd.left + 'px',
				top: pointEnd.top + 'px'
			}, speed, function () {
				me.pointName = pointEndName;
				run(end, end + 1);
			});
		}
		else {
			me.moving = false;
		}
	}
	run(0, 1);
};
module.exports = LineMove;